<template lang="html">
  <div v-if="clients && clients.length">
    <div class="select-list">
      <button v-for="(item, i) in clientList" :key="i" @click="fetchLogs({ clientId: item.clientId })" :class="{ selected: selectedClientId==item.clientId}">{{ item.name || item.clientId || 'undefined' }}</button>
    </div>
    <flex dir="column" class="content">
      <div class="header">
        <h1>{{ selectedName || 'undefined' }}</h1>
        <butter-text-field label="Search User ID" :value="$route.query.userId" type="number" @input="fetchLogs({ userId: $event })" :inputDelay="200" />
      </div>
      <flex v-if="logs.length" dir="column">
        <flex dir="row" class="actions">
          <time-range icon="calendar" label="logs" :times="logsPage" @update="showCalendar=true" @clear="fetchLogs({})" />
          <div id="download-logs"></div>
        </flex>
        <butter-table theme="mono" :header="logsHeader" :data="logsTable" />
        <flex dir="row" class="actions">
          <butter-options :options="ranges" :value="range" @change="range=String($event)">
            <butter-icon name="clock" width="17" height="16" class="icon" />
            <span @click="extendTime">Extend range by: {{ selectedRange.label }}</span>
          </butter-options>
          <butter-button theme="filter" size="ui" @click="jumpToNow">
            <butter-icon name="arrow-up" width="13" height="12" class="icon" />
            <span>Jump to now</span>
          </butter-button>
        </flex>
      </flex>
      <flex v-else dir="column" class="empty">
        <butter-icon name="person" />
        <p>Your logs are empty.</p>
      </flex>
      <modal v-show="showCalendar" size="medium">
        <div id="date-picker"></div>
      </modal>
    </flex>
  </div>
</template>

<script>
import React from 'react'
import ReactDOM from 'react-dom'
import DatePicker from 'butter-vue/lib/react-components/date_picker'
import DownloadCSV from 'butter-vue/lib/react-components/download_csv'

const ONEHOUR = 60 * 60 * 1000
const SIXHOURS = ONEHOUR * 6
const TWENTYFOURHOURS = ONEHOUR * 24
const TIME_RANGES = [{
    value: ONEHOUR,
    label: '1 hour'
  }, {
    value: SIXHOURS,
    label: '6 hours'
  }, {
    value: TWENTYFOURHOURS,
    label: '24 hours'
  }]
function brdTime (timestamp) {
  return {
    now: new Date(timestamp),
    onehr: new Date(timestamp + ONEHOUR)
  }
}
export default {
  props: {
    'logs': {
      default: [],
    },
    'clients': {
      default: []
    },
    'clientId': {
      default: -1
    },
    'logsPage': {
      default() {
        const brdtime = brdTime(Date.now());
        return {
          start: brdtime.now,
          end: brdtime.onehr
        }
      }
    }
  },
  mounted() {
    this.renderReact()
  },
  data() {
    return {
      range: String(ONEHOUR),
      showCalendar: false
    }
  },
  computed: {
    clientList() {
      return [{
        name: 'All Clients',
        clientId: -1
      }, ...this.clients];
    },
    logsHeader() {
      return [
        {value: "Created", span: 3},
        {value: "Remote", span: 2},
        {value: "Client", span: 2},
        {value: "Status", span: 2},
        {value: "Request", span: 6}
      ];
    },
    logsTable() {
      return this.logs.map(l => [
        {value: l.created, span: 3},
        {value: l.remote, span: 2},
        {value: l.client, span: 2},
        {value: l.status, span: 2},
        {value: l.request, span: 6}
      ]);
    },
    selectedClientId() {
      if (!this.clientId) return -1
      return this.clientId
    },
    selectedName() {
      const client = this.clientList.find(c => c.clientId == this.selectedClientId)
      return client.name || client.clientId
    },
    ranges() {
      return TIME_RANGES
    },
    selectedRange() {
      return this.ranges.find(r => r.value === Number(this.range))
    }
  },
  methods: {
    renderReact() {
      const downloadBtn = document.getElementById('download-logs')
      const datePicker = document.getElementById('date-picker')
      if (datePicker) {
        ReactDOM.render(React.createElement(DatePicker), datePicker)
        document.addEventListener('DatePicker:closeModal', _ => this.showCalendar = false)
        document.addEventListener('DatePicker:showLogs', ({ detail }) => {
          this.fetchLogs({ nextPage: detail })
          this.showCalendar = false
        })
      }

      if (downloadBtn) {
        ReactDOM.render(React.createElement(DownloadCSV, { logs: this.logsTable }), downloadBtn)
      }
    },
    fetchLogs({ clientId = null, nextPage = null, userId = null }) {
      this.$emit('fetchLogs', { clientId, nextPage, userId })
      this.renderReact()
    },
    jumpToNow() {
      this.fetchLogs({ nextPage: Date.now() })
    },
    extendTime() {
      const nextPage = this.logsPage.end.getTime() - this.range
      this.fetchLogs({ nextPage })
    }
  },
}
</script>
